# -*- coding: utf-8 -*-
#
# Configuration file for the Sphinx documentation builder.
#
# This file does only contain a selection of the most common options. For a
# full list see the documentation:
# http://www.sphinx-doc.org/en/stable/config

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#

import datetime
import os
import sys
import inspect
from subprocess import Popen

import sphinxcontrib.katex as katex

# -- Automated generation -----------------------------------------------------

def recurse_api_source(file, pre):
    if file.endswith(".rst") or "generated" in file:
        return

    if not pre.endswith('/'):
        pre += '/'

    Popen("sphinx-autogen *.rst", shell=True, cwd=pre+file)

    for sub_file in os.listdir(pre + file):
        recurse_api_source(sub_file, pre + file)

def run_autogen():
    filename = inspect.getframeinfo(inspect.currentframe()).filename
    path = os.path.dirname(os.path.abspath(filename)) + "/api"

    Popen("sphinx-autogen *.rst", shell=True, cwd=path)

    for file in os.listdir(path):
        recurse_api_source(file, path)

# -- Project information -----------------------------------------------------

def reformat_authors(names):
    if len(names) >= 2:
        return '{} and {}'.format(', '.join(names[:-1]), names[-1])
    return '{}'.format(names[0])

project = 'Finesse 3.0'
authors = ['Andreas Freise', 'Daniel Brown', 'the Finesse team']
authors_str = reformat_authors(authors)
copyright = u'1999 to {} by {}'.format(datetime.datetime.now().year, ' {}'.format(authors_str))
ligo_dcc_no = 'LIGO-T1300431'
ligo_dcc = 'This document has been assigned the LIGO DCC number: {}.'.format(ligo_dcc_no)

# The short X.Y version
version = '3.0'
# The full version, including alpha/beta/rc tags
release = '3.0-alpha'


# -- General configuration ---------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#

needs_sphinx = '2.1.1'

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    'sphinx.ext.autodoc',
    'sphinx.ext.autosummary',
    'sphinx.ext.doctest',
    'sphinx.ext.intersphinx',
    'sphinx.ext.todo',
    'sphinx.ext.coverage',
    'sphinxcontrib.katex',
    'sphinx.ext.ifconfig',
    'sphinx.ext.viewcode',
    'sphinxcontrib.bibtex',
    'sphinx.ext.todo',
    'numpydoc',
]
#    'sphinx.ext.mathjax',

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = '.rst'

# The master toctree document.
master_doc = 'index'

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path .
exclude_patterns = []

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'friendly'

# If true, figures, tables and code-blocks are automatically numbered
# if they have a caption. The numref role is enabled. Obeyed so far
# only by HTML and LaTeX builders.
numfig = True


# If this is True, todo and todolist produce output **in the manual**,
todo_include_todos = True
# show all todo items as warning on compile?
todo_emit_warnings = False

# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
try:
    import sphinx_rtd_theme
    html_theme = 'sphinx_rtd_theme'
    html_theme_path = [sphinx_rtd_theme.get_html_theme_path()]
except ImportError:
    print("Error: sphinx_rtd_theme not installed, run pip install sphinx_rtd_theme (or similar) to acquire.")
    exit(-1)

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#
html_theme_options = {
    'logo_only': True,
     'collapse_navigation': False, # Collapse navigation (False makes it tree-like)
     }

# explicitly include __init__ method in documentation
# -> alternative to autoclass_content='both' below which
#    produced duplicate autosummaries in some cases
def skip(app, what, name, obj, skip, options):
    if name == '__init__':
        return False
    return skip

def setup(app):
    app.add_stylesheet('theme_overrides.css')
    app.connect("autodoc-skip-member", skip)
    # recursively run sphinx-autogen through docs/api/
    run_autogen()

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

# Custom sidebar templates, must be a dictionary that maps document names
# to template names.
#
# The default sidebars (for documents that don't match any pattern) are
# defined by theme itself.  Builtin themes are using these templates by
# default: ``['localtoc.html', 'relations.html', 'sourcelink.html',
# 'searchbox.html']``.
#
# html_sidebars = {}

html_logo = 'images/finesse_logo.png'

# -- Options for HTMLHelp output ---------------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = 'Finesse3_doc'

# don't show links to page sources
html_show_sourcelink = False

# -- Options for LaTeX output ------------------------------------------------

pdf_info = """
    \\pdfinfo{{/Title (FINESSE 3.0, Frequency domain INterferomEter Simulation SoftwarE)
            /Subject (FINESSE manual)
            /Author ({authors})
            /Keywords (interferometer;simulation;gravitational wave; optics)}}
""".format(authors=authors_str)


latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    #
    'papersize': 'a4paper',

    # The font size ('10pt', '11pt' or '12pt').
    #
    'pointsize': '10pt',

    # Fancy chapter titles
    'fncychap' : '\\usepackage[Bjornstrup]{fncychap}',

    # remove extra empty pages for 'manual'
    'extraclassoptions': 'openany,oneside',

    # Additional stuff for the LaTeX preamble.
    #
    'preamble': """
    \\usepackage{verbatim}
    \\usepackage{amsmath, amssymb}
    \\PassOptionsToPackage{dvipsnames,svgnames}{xcolor}
    \\usepackage{parskip}
    \\usepackage{xspace}
    \\PassOptionsToPackage{german, english}{babel}
    \\usepackage{datetime}
    \\newdateformat{MY}{\\monthname[\\THEMONTH], \\THEYEAR}
    \\usepackage{bigints}
    \\PassOptionsToPackage{hyphens}{url}
    \\PassOptionsToPackage{pdftex,a4paper,pagebackref=true,pdfpagelabels=true,breaklinks=true}{hyperref}
    \\definecolor{linkcolor}{rgb}{.8,0,0}
    \\definecolor{urlcolor}{rgb}{0,0,.7}
    \\definecolor{citecolor}{rgb}{0,.5,0}
    \\definecolor{acrocolor}{rgb}{0,0,.7}
    \\hypersetup{bookmarksopen,colorlinks=true}
    \\hypersetup{pdfstartview=FitH}
    \\hypersetup{linktocpage=true,bookmarksnumbered=true}
    \\hypersetup{plainpages=false,breaklinks=true}
    \\hypersetup{linkcolor=linkcolor,citecolor=citecolor,urlcolor=urlcolor}
    \\usepackage{float}
    \\usepackage{tabularx}
    \\usepackage{mdframed}
    %\\usepackage{makeidx}
    %\\makeindex
    \\let \\IG \\includegraphics
    \\newcommand{\katcode}[1]{{\\tt\\small #1}}
    \\newcommand{\\mFig}[1]{Figure~\\ref{#1}}
    \\newcommand{\\mfig}[1]{figure~\\ref{#1}}
    \\usepackage{fancyvrb}
    \\newcommand{\\tcr}{\\textcolor{red}}
    \\newcommand{\\tcb}{\\textcolor{blue}}
    \\newcommand{\\tcm}{\\textcolor{magenta}}
    \\newcommand{\\tcg}{\\textcolor{green}}
    %\\renewcommand{\\tcr}{}\\renewcommand{\\tcb}{}\\renewcommand{\\tcm}{}\\renewcommand{\\tcg}{}

    \\DefineVerbatimEnvironment{finesse}{Verbatim}{formatcom=\\small}
    \\definecolor{katbg}{rgb}{0.99,0.99,0.99}
    \\newmdenv[linecolor=blue,backgroundcolor=katbg,innermargin =+0.5cm, outermargin =+0.5cm]{katbox}
    \\fvset{fontsize=\\small}

    \\newcommand{\\Finesse}{\\textsc{Finesse}\\xspace}

    \\newcommand{\\loadkat}[1]{
    \\begin{katbox}
    \\VerbatimInput{files/#1}
    \end{katbox}
    }

    \\newcommand{\\iprod}[1]{\\left\\langle #1 \\right\\rangle}

    % dummy counter, needed for correct page references inside the text
    \\newcounter{dummy}
    \\setcounter{tocdepth}{1}

    % TODO: check and remove
    % switch on new stuff by using
    %\\usepackage[new]{optional}

    """+pdf_info,

    'maketitle' : """
    \\pagenumbering{Roman}
    \\begin{titlepage}
    \\pdfbookmark[1]{Title}{title}

    \\begin{center}
    \\includegraphics [angle=0,scale=1] {ascii_rider_finesse_3}\\hspace{2mm}~

    {\\LARGE %{\\bf FINESSE 3.0} \\\\ \\vspace{1cm}Frequency domain INterferomEter Simulation SoftwarE}
    \\vspace{1.2cm}Frequency domain INterferomEter Simulation SoftwarE}
    \\vspace{.2cm}

    {\\Large \\href{http://www.gwoptics.org/finesse}{www.gwoptics.org/finesse}}

    \\end{center}
    \\vspace{3cm}
    {\\textbf{Note:} This is the documentation for \\Finesse 3, which is in a
    pre-alpha stage of development. You can find the documentaton, executables and code
    for the stable \\Finesse 2 at \\url{http://www.gwoptics.org/finesse.}
}
    \\vfill

    \\begin{center}
    %\\thedate
    \\newcommand{\\mydate}{\\MY\\formatdate{1}{5}{2018}}
    \\mydate
    \\end{center}
    \\end{titlepage}
    \\thispagestyle{empty}


    \\Finesse is a fast and easy to use Python-based interferometer simulation program.
    It uses frequency-domain optical modelling to build accurate
    quasi-static simulations of arbitrary interferometer configurations.

    For convenience, a number of standard analyses can be performed
    automatically by the program, namely computing modulation-demodulation error
    signals, transfer functions, quantum-noise-limited sensitivities, and beam
    shapes. The optical system can be modelled using the plane-wave
    approximation or Hermite-Gauss modes, allowing the computation of
    optical systems like telescopes or the effects of mode matching
    and mirror angular positions.

    \\Finesse is based on an object-oriented design and provvides a large set of uttility
    function for ease of use when handling complex simulation tasks, for example:
    chained simulations, advanced plotting of outputs, automation of simulations,
    the use of Jupyter notebooks to document simulation tasks, and much more!

    \\vspace*{\\fill}
    \\Finesse, the accompanying documentation, and the example files
    have been written by:
    """
    + authors_str +
    """.
    %\\href{mailto:andreas.freise@googlemail.com}{andreas.freise@googlemail.com}

    \\textsc{The software and documentation is provided as is without any warranty
    of any kind.}
    \\textsc{Copyright \\copyright\\ """
    + copyright + """}.

    The source code for \\Finesse is available as open source under the
    GNU General Public License version 3 as published by the Free Software Foundation.

    This manual and all \Finesse documentation and examples available from
    \\href{http://www.gwoptics.org/finesse}{\\nolinkurl{www.gwoptics.org/finesse}}
    and related pages are distributed under
    a Creative Commons Attribution-Non\\-com\\-mercial-Share Alike License,
    see \\href{http://creativecommons.org/licenses/by-nc-sa/2.0/uk/}{\\nolinkurl{http://creativecommons.org/licenses/by-nc-sa/2.0/uk/}}.

    """ + ligo_dcc + """

    \\thispagestyle{empty}
    \\clearpage
    \\pagenumbering{arabic}
    """,

    # Latex figure (float) alignment
    #
    'figure_align': 'htbp',
}

# A list of file names, relative to the configuration directory, to copy to the build directory
# when building LaTeX output. This is useful to copy files that Sphinx doesn’t copy automatically,
#latex_additional_files = ['finesse.sty', 'images/logo.pdf', 'images/ascii_rider_finesse_3.pdf']
latex_additional_files = ['images/logo.pdf', 'images/ascii_rider_finesse_3.pdf']

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (master_doc, 'Finesse3.tex', 'Finesse 3 Documentation',
     'Andreas Freise, Daniel Brown, Philip Jones, Samuel Rowlinson', 'manual', True),
]

# -- add KaTeX math macros ----------------------

file = open('math_macros.sty', 'r')
latex_macros = file.read()
# Translate LaTeX macros to KaTeX and add to options for HTML builder
katex_macros = katex.latex_defs_to_katex_macros(latex_macros)
katex_options = 'macros: {' + katex_macros + '}'

# Add LaTeX macros for LATEX builder
latex_elements['preamble'] += latex_macros

# -- Options for manual page output ------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, 'finesse3', 'Finesse 3 Documentation',
     authors, 1)
]


# -- Options for Texinfo output ----------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, 'Finesse3', 'Finesse 3 Documentation',
     authors, 'Finesse 3', 'New Python based development of Finesse interferometer simulation.',
     'Miscellaneous'),
]


# -- Options for Epub output -------------------------------------------------

# Bibliographic Dublin Core info.
epub_title = project
epub_author = ', '.join(authors)
epub_publisher = ', '.join(authors)
epub_copyright = copyright

# The unique identifier of the text. This can be a ISBN number
# or the project homepage.
#
# epub_identifier = ''

# A unique identification for the text.
#
# epub_uid = ''

# A list of files that should not be packed into the epub file.
epub_exclude_files = ['search.html']

# -- Extension configuration -------------------------------------------------

# -- Options for intersphinx extension ---------------------------------------

# Example configuration for intersphinx: refer to the Python standard library.
intersphinx_mapping = {
    'https://docs.python.org/': None,
    'numpy' : ('https://docs.scipy.org/doc/numpy/', None),
    'scipy' : ('https://docs.scipy.org/doc/scipy/reference/', None),
    'matplotlib' : ('https://matplotlib.org/', None),
    'networkx' : ('https://networkx.github.io/documentation/stable/', None),
}

# -- Options for todo extension ----------------------------------------------

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = True

# -- Options for autodoc extension -------------------------------------------

#autoclass_content='both'

# -- Options for numpydoc extension ------------------------------------------

try:
    import numpydoc
    try:
        print("Using numpydoc v{} for docstrings formatting.".format(numpydoc.__version__))
    except AttributeError: # numpydoc.__version__ not defined in some old versions for some reason
        print("Using numpydoc for docstrings formatting. NOTE: current numpydoc version\
        is outdated, please upgrade your numpydoc package.")
except ImportError:
    print("Error: documentation build failed, numpydoc package not found. Install numpydoc\
    to build successfully.")
    exit(-1)

# whether to show all members of a class in the Methods and Attributes sections
# automatically
numpydoc_show_class_members = False

# whether to create a Sphinx table of contents for the lists of class methods and
# attributes. If a table of contents is made, Sphinx expects each entry to have
# a separate page
numpdoc_class_members_toctree = False

# until version 0.8, parameter definitions were shown as blockquotes, rather than in a definition
# list. If your styling requires blockquotes, switch this config option to True. This option will
# be removed in version 0.10 - NEED TO FIND ALTERNATIVE, SETTING THIS TO FALSE FORMATS PARAMETER
# DEFINITIONS WITH TYPES IN AN UGLY WAY
numpydoc_use_blockquotes = True
